blog/urls.py
from django.urls import path

from . import views
from .views import ArticleDetail, CategoryDetail

app_name = 'blog'

urlpatterns = [
    # Articles
    path('', views.article_list, name='article_list'),
    path("<slug:slug>", ArticleDetail.as_view(), name="article-detail"),

    # Categories
    path('list/', views.category_list, name='category_list'),
    path("<slug:slug>", CategoryDetail.as_view(), name="category-detail"),


]

jobs/urls.py
from django.urls import  path

from . import views

app_name = 'jobs'

urlpatterns = [
    path('', views.job_list, name='job_list'),
    path('create-job', views.create_job, name='create_job'),
    path("<slug:slug>", views.job_detail, name="job_detail"),

    # Categories
    path('categories/', views.categories_list, name='categories_list'),
    path("categories/<slug:slug>/", views.category_list, name="category-list"),
]

project/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('accounts/', include('django.contrib.auth.urls')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('admin/', admin.site.urls),
    path('jobs/', include('jobs.urls', namespace='jobs')),
    path('contact', include('contact.urls', namespace='contact')),
    path('blog/', include('blog.urls', namespace='blog')),
    path('', include('home.urls', namespace='home')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

jobs/models.py
from django.contrib.auth.models import User
from django.db import models
from django.template.defaultfilters import slugify
from django.urls import reverse
from pyexpat import model


# To customize how user uploads his image into your media file
def upload_location(instance, filename):
    filebase, extension = filename.split('.')
    return 'images/%s.%s' % (instance.title, extension)


class Job(models.Model):
    JOB_TYPE = (
        ('Full Time', 'Full Time'),
        ('Part Time', 'Part Time'),
    )

    owner = models.ForeignKey(User, related_name='job_owner', on_delete=models.CASCADE)
    title = models.CharField(max_length=101)
    slug = models.SlugField(unique=True, max_length=200, blank=True)
    # location
    job_type = models.CharField(max_length=15, choices=JOB_TYPE)
    description = models.TextField(max_length=1000, null=True, blank=True)
    published_at = models.DateTimeField(auto_now=True, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now_add=True, null=True, blank=True)
    vacancy = models.IntegerField(default=0)
    salary = models.IntegerField(default=0)
    experience = models.IntegerField(default=0)
    category = models.ForeignKey('Category', on_delete=models.CASCADE, null=True, default='Category')
    image = models.ImageField(upload_to=upload_location, null=True, blank=True)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('jobs:job_detail', kwargs={"slug": self.slug})

    # To Slugify a URL
    def save(self, *args, **kwargs):
        if not self.slug:
            self.slug = slugify(self.title)
        super().save(*args, **kwargs)


class Category(models.Model):
    name = models.CharField(max_length=25)
    slug = models.SlugField(max_length=200, blank=True)
    description = models.TextField(max_length=1000, null=True, blank=True)
    created_on = models.DateTimeField(auto_now=True, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now_add=True, null=True, blank=True)

    class Meta:
        ordering = ['-created_on']
        verbose_name = ('Category')
        verbose_name_plural = ('Categories')

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('jobs:job_list', kwargs={"slug": self.slug})

    # To Slugify a URL
    def save(self, *args, **kwargs):
        if not self.slug:
            self.slug = slugify(self.name)
        super().save(*args, **kwargs)


class Apply(models.Model):
    name = models.CharField(max_length=50)
    email = models.EmailField(max_length=100)
    website = models.URLField(max_length=200)
    cv = models.FileField(upload_to='apply/')
    cover_letter = models.CharField(max_length=500)
    job = models.ForeignKey(Job, related_name='apply_job', on_delete=models.CASCADE)
    created_on = models.DateTimeField(auto_now=True, null=True, blank=True)
    updated_on = models.DateTimeField(auto_now_add=True, null=True, blank=True)

    class Meta:
        ordering = ['-created_on']
        verbose_name = ('Apply')
        verbose_name_plural = ('Applications')

    def __str__(self):
        return self.name

jobs/forms.py
from django import forms
from .models import Apply, Job


class ApplyForm(forms.ModelForm):
    class Meta:
        model = Apply
        fields = ('name', 'email', 'website', 'cover_letter', 'cv')


class JobForm(forms.ModelForm):
    class Meta:
        model = Job
        fields = ('title', 'description', 'vacancy', 'salary', 'experience', 'image', 'job_type', 'category')

jobs/views.py
from django.core.paginator import Paginator
from django.shortcuts import render, redirect
from django.urls import reverse
from django.views import generic
from django.views.generic import DetailView

from .filters import JobFilter
from .models import Job, Category
from .forms import Apply, ApplyForm, JobForm


# Create your views here.
def job_list(request):
    job_list = Job.objects.all()
    category_list = Category.objects.all()

    ## FILTERS
    myFilter = JobFilter(request.GET, queryset=job_list)
    job_list = myFilter.qs

    paginator = Paginator(job_list, 6)
    page_number = request.GET.get('page')
    page_obj = paginator.get_page(page_number)

    context = {
        'jobs': page_obj,
        'categories': category_list,
        'myFilter': myFilter,
    }
    return render(request, 'job/job_list.html', context)





def job_detail(request, slug):
    job_detail = Job.objects.get(slug=slug)

    if request.method == 'POST':
        form = ApplyForm(request.POST, request.FILES)
        if form.is_valid():
            myform = form.save(commit=False)
            myform.job = job_detail
            myform.save()
            print('DONE')
    else:
        form = ApplyForm()

    context = {
        'jobs': job_detail,
        'forms': form,
    }
    return render(request, 'job/job_detail.html', context)


def create_job(request):
    if request.method == 'POST':
        form = JobForm(request.POST, request.FILES)
        if form.is_valid():
            myform = form.save(commit=False)  # Don't save in DB Yet
            myform.owner = request.user
            myform.save()
            return redirect(reverse('jobs:job_list'))
    else:
        form = JobForm()

    context = {
        'form': form,
    }
    return render(request, 'job/create_job.html', context)


def categories_list(request):
    category_list = Category.objects.all()

    paginator = Paginator(category_list, 6)
    page_number = request.GET.get('page')
    page_obj = paginator.get_page(page_number)

    context = {
        'paginator': page_obj,
        'categories': category_list,
    }
    return render(request, 'job/categories_list.html', context)


def category_list(request, slug):
    jobs_list = Category.objects.filter(slug=slug)

    paginator = Paginator(jobs_list, 6)
    page_number = request.GET.get('page')
    page_obj = paginator.get_page(page_number)

    context = {
        'paginator': page_obj,
        'jobs_list': jobs_list,
    }
    return render(request, 'job/category_list.html', context)

jobs/templates/job/categories_list.html
{% extends 'base.html' %}
{% load bootstrap5 %}
{% block body %}



    <!---------- HERO SECTION ---------->
    <div class="bradcam_area bradcam_bg_1">
        <div class="container">
            <div class="row">
                <div class="col-xl-12">
                    <div class="bradcam_text">
                        <h3>Job Categories</h3>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!---------- HERO SECTION ---------->

    <!-- job_listing_area_start  -->
    <div class="job_listing_area plus_padding">
        <div class="container ">
            <div class="row">





                    <!---------- CATEGORY LIST ---------->
                    <div class="job_lists m-0 ">
                        <div class="row">
                            {% for category in categories %}
                                <div class="col-lg-12 col-md-12">
                                    <div class="single_jobs white-bg d-flex justify-content-between">
                                        <div class="jobs_left d-flex align-items-center">

                                            <div class="thumb">
                                                {% if category.image %}
                                                    <img src="{{ category.image.url }}" alt="">
                                                {% else %}
                                                   <p>No Image</p>
                                                {% endif %}
                                            </div>

                                            <div class="jobs_conetent">
                                                <a href="{% url 'jobs:category-list' category.slug %} "><h4>{{ category.name }}</h4></a>
                                                <p>{{ category.description | truncatewords:30 }}</p>
                                                <div class="links_locat d-flex align-items-center">
                                                    <div class="location">
                                                        <p> <i class="fa fa-map-marker"></i> California, USA (STATIC)</p>
                                                    </div>

                                                </div>
                                            </div>
                                        </div>

                                    <div class="jobs_right">

                                        <div class="apply_now">
                                            <a class="heart_mark" href="#"> <i class="fa fa-heart"></i> </a>
                                            <a href={%  url 'jobs:category-list' category.slug %} class="boxed-btn3">View Category</a>
                                        </div>

                                        <div class="date">
                                            <p>Date line: {{ category.created_on|date:'d, M, o'}}</p>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        {% endfor %}
                        <!---------- CATEGORY LIST ENDS ---------->


                    <!-------------- PAGINATOR ----------------->
                    </div>
                        {% if categories.has_other_pages %}
                            <div class="row">
                                <div class="col-lg-12">
                                    <div class="pagination_wrap">
                                        <ul>
                                            <!-- Check if it has previous pages to display previous arrow -->
                                            {% if categories.has_previous %}
                                                <li><a href="?page={{ categories.previous_page_number }}"> <i class="ti-angle-left"></i> </a></li>
                                            {% endif %}

                                            <!-- Check the pages I have  -->
                                            {% for i in categories.paginator.page_range %}
                                                 <li><a href="?page={{ i }}"><span>{{ i }}</span></a></li>
                                            {%  endfor %}


                                            <!-- Check if it has next pages to display next arrow -->
                                            {% if categories.has_next %}
                                                <li><a href="?page={{ categories.next_page_number }}"> <i class="ti-angle-right"></i> </a></li>
                                            {% endif %}
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    </div>
                    <!-------------- PAGINATOR ----------------->
                </div>
            </div>
        </div>
    </div>
    <!-- job_listing_area_end  -->

{% endblock body %}

jobs/templates/job/category_list.html
{% extends 'base.html' %}
{% load bootstrap5 %}
{% block body %}



    <!-- bradcam_area  -->
    <div class="bradcam_area bradcam_bg_1">
        <div class="container">
            <div class="row">
                <div class="col-xl-12">
                    <div class="bradcam_text">
                        <h3>{{ cats.count }}+ Jobs Available</h3>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--/ bradcam_area  -->

    <!-- job_listing_area_start  -->
    <div class="job_listing_area plus_padding">
        <div class="container">
            <div class="row">
                <div class="col-lg-9">
                    <div class="recent_joblist_wrap">
                        <div class="recent_joblist white-bg ">
                            <div class="row align-items-center">
                                <div class="col-md-6">
                                    <h4>Job Listing</h4>
                                </div>
                                <div class="col-md-6">
                                    <div class="serch_cat d-flex justify-content-end">
                                        <select>
                                            <option data-display="Most Recent">Most Recent</option>
                                            <option value="1">Marketer</option>
                                            <option value="2">Wordpress </option>
                                            <option value="4">Designer</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Job List -->
                    <div class="job_lists m-0">
                        <div class="row">

                            {% for job in jobs_list %}
                                <div class="col-lg-12 col-md-12">
                                    <div class="single_jobs white-bg d-flex justify-content-between">
                                        <div class="jobs_left d-flex align-items-center">
                                            <div class="thumb">
                                                {% if job.image %}
                                                    <img src="{{ job.image.url }}" alt="">
                                                {% else %}
                                                   <p>No Image</p>
                                                {% endif %}
                                            </div>

                                            <div class="jobs_conetent">
                                                <a href="{% url 'jobs:job_detail' job.slug %} "><h4>{{ job.title }}</h4></a>
                                                <div class="links_locat d-flex align-items-center">
                                                    <div class="location">
                                                        <p> <i class="fa fa-map-marker"></i> California, USA (STATIC)</p>
                                                    </div>

                                                    <div class="location">
                                                        <p> <i class="fa fa-clock-o"></i>{{ job.job_type }}</p>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                    <div class="jobs_right">

                                        <div class="apply_now">
                                            <a class="heart_mark" href="#"> <i class="fa fa-heart"></i> </a>
                                            <a href={%  url 'jobs:job_detail' job.slug %} class="boxed-btn3">Apply Now</a>
                                        </div>

                                        <div class="date">
                                            <p>Date line: {{ job.published_at|date:'d, M, o'}}</p>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        {% endfor %}



                    <!-------------- PAGINATOR ----------------->
                    </div>
                        {% if cats.has_other_pages %}
                            <div class="row">
                                <div class="col-lg-12">
                                    <div class="pagination_wrap">
                                        <ul>
                                            <!-- Check if it has previous pages to display previous arrow -->
                                            {% if cats.has_previous %}
                                                <li><a href="?page={{ cats.previous_page_number }}"> <i class="ti-angle-left"></i> </a></li>
                                            {% endif %}

                                            <!-- Check the pages I have  -->
                                            {% for i in cats.paginator.page_range %}
                                                 <li><a href="?page={{ i }}"><span>{{ i }}</span></a></li>
                                            {%  endfor %}


                                            <!-- Check if it has next pages to display next arrow -->
                                            {% if cats.has_next %}
                                                <li><a href="?page={{ cats.next_page_number }}"> <i class="ti-angle-right"></i> </a></li>
                                            {% endif %}
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    </div>
                    <!-------------- PAGINATOR ----------------->
                </div>
            </div>
        </div>
    </div>
    <!-- job_listing_area_end  -->

{% endblock body %}

jobs/templates/job/create_job.html
{% extends 'base.html' %}
{% load bootstrap5 %}
{% block body %}



    <!-- bradcam_area  -->
    <div class="bradcam_area bradcam_bg_1">
        <div class="container">
            <div class="row">
                <div class="col-xl-12">
                    <div class="bradcam_text">
                        <h3>Post New Job</h3>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--/ bradcam_area  -->

    <div class="job_details_area">
        <div class="container">
            <div class="row">
                <div class="col-lg-10 mx-auto">
                    <div class="apply_job_form white-bg">
                        <h4>Write Job Information</h4>
                        <form method = 'POST' enctype="multipart/form-data">
                            <div>
                                {% csrf_token %}
                                {% bootstrap_form form %}

                                <button class="boxed-btn3 w-100 mt-5" type="submit">Post New Job</button>
                            </div>
                        </form>
                    </div>
                </div>

            </div>
        </div>
    </div>

{% endblock body %}

jobs/templates/job/job_detail.html
{% extends 'base.html' %}
{% load bootstrap5 %}
{% block body %}



    <!-- bradcam_area  -->
    <div class="bradcam_area bradcam_bg_1">
        <div class="container">
            <div class="row">
                <div class="col-xl-12">
                    <div class="bradcam_text">
                        <h3>{{ jobs.title }}</h3>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!--/ bradcam_area  -->

    <div class="job_details_area">
        <div class="container">
            <div class="row">
                <div class="col-lg-8">
                    <div class="job_details_header">
                        <div class="single_jobs white-bg d-flex justify-content-between">
                            <div class="jobs_left d-flex align-items-center">
                                <div class="thumb">
                                    <img src="img/svg_icon/1.svg" alt="">
                                </div>
                                <div class="jobs_conetent">
                                    <a href="#"><h4>{{ jobs.title }}</h4></a>
                                    <div class="links_locat d-flex align-items-center">
                                        <div class="location">
                                            <p> <i class="fa fa-map-marker"></i> California, USA</p>
                                        </div>
                                        <div class="location">
                                            <p> <i class="fa fa-clock-o"></i> {{ jobs.job_type }}</p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="jobs_right">
                                <div class="apply_now">
                                    <a class="heart_mark" href="#"> <i class="ti-heart"></i> </a>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="descript_wrap white-bg">
                        <div class="single_wrap">
                            <h4>Job description</h4>
                            <p>{{ jobs.description }}</p>
                        </div>

                    </div>
                    <div class="apply_job_form white-bg">
                        <h4>Apply for the job</h4>


                        <form method = 'POST' enctype="multipart/form-data">
                            <div>
                                    {% csrf_token %}
                                    {% bootstrap_form forms %}
                                    <button class="boxed-btn3 w-100" type="submit">Apply Now</button>
                            </div>
                        </form>



                    </div>
                </div>
                <div class="col-lg-4">
                    <div class="job_sumary">
                        <div class="summery_header">
                            <h3>Job Summery</h3>
                        </div>
                        <div class="job_content">
                            <ul>
                                <li>Published on: <span>{{ jobs.published_at|date:'d, M, o'}}</span></li>
                                <li>Vacancy: <span>{{ jobs.vacancy }}</span></li>
                                <li>Salary: <span>{{ jobs.salary }}k/y </span></li>
                                <li>Location: <span>California, USA</span></li>
                                <li>Job Nature: <span>{{ jobs.job_type }}</span></li>
                            </ul>
                        </div>
                    </div>
                    <div class="share_wrap d-flex">
                        <span>Share at:</span>
                        <ul>
                            <li><a href="#"> <i class="fa fa-facebook"></i></a> </li>
                            <li><a href="#"> <i class="fa fa-google-plus"></i></a> </li>
                            <li><a href="#"> <i class="fa fa-twitter"></i></a> </li>
                            <li><a href="#"> <i class="fa fa-envelope"></i></a> </li>
                        </ul>
                    </div>
                    <div class="job_location_wrap">
                        <div class="job_lok_inner">
                            <div id="map" style="height: 200px;"></div>
                            <script>
                              function initMap() {
                                var uluru = {lat: -25.363, lng: 131.044};
                                var grayStyles = [
                                  {
                                    featureType: "all",
                                    stylers: [
                                      { saturation: -90 },
                                      { lightness: 50 }
                                    ]
                                  },
                                  {elementType: 'labels.text.fill', stylers: [{color: '#ccdee9'}]}
                                ];
                                var map = new google.maps.Map(document.getElementById('map'), {
                                  center: {lat: -31.197, lng: 150.744},
                                  zoom: 9,
                                  styles: grayStyles,
                                  scrollwheel:  false
                                });
                              }

                            </script>
                            <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDpfS1oRGreGSBU5HHjMmQ3o5NLw7VdJ6I&callback=initMap"></script>

                          </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

{% endblock body %}